################################################################################################################################################################
#          UNIVERSIDADE FEDERAL FLUMINENSE - UFF                                                                                                               #
#          Ps Graduao em Computao                                                                                                                         #
#          Disciplina de Redes de Computadores - 2017-2                                                                                                        #
#                                                                                                                                                              #
#                                                                                                                                                              #
#                                                                                                                                                              # 
#                       Este programa analisa um arquivo Trace com os dados gerados por um trfego CBR sobre UDP e calcula:                                    #
#                                                                                                                                                              # 
#                                    			Pacotes enviados;                                                                                              #
#                                    			Pacotes recebidos;                                                                                             # 
#                                               Pacotes perdidos (descartados);                                                                                #
#									            Vazo em Kbit/s;                                                                                               #
#                                               Atraso (ms).                                                                                                   # 
#                                                                                                                                                              # 
#                  Observao: Para execut-lo, digitar: $  gawk -f resultados-exemplo1.awk  out-VAPkt.tr                                                      # 
#                                                                                                                                                              #
################################################################################################################################################################


BEGIN {



################################################################################################################################################################

#                    rea de inicializao das variveis do programa                   

fsDrops = 0;       

numFs = 0;         


recvdSize = 0
startTime = 1e8
stopTime = 0



################################################################################################################################################################

}



{

acao = $1;

tempo = $2;

fonte = $3;

destino = $4;

tipo = $5;

pktsize = $6;

flow_id = $8;

src = $9;

dst = $10;

seq_no = $11;

packet_id = $12;




##################################################################################################################################################################
#                                                                                                                                                                #
#                              rea de clculo do tempo, tamanho dos pacotes                                                                                     #
#                                                                                                                                                                #  
##################################################################################################################################################################


if (acao == "+" || acao == "-") node_id = $3 
if (acao == "r" || acao == "d") node_id = $4
 
 
		
		
		
			
# Tempo para enviar os pacotes


	if (flow_id == 0 && node_id == 0 &&
	    sendTime[packet_id] == 0 && (acao == "+" || acao == "s") && pktsize >= 1000) {
		if (tempo < startTime) {
			startTime = tempo
		}
		sendTime[packet_id] = tempo
		this_flow = tipo
	}


# Update do total de pacotes recebidos, tamanho e armazenar tempo de pacotes recebidos


	if (flow_id == 0 && node_id == 1 &&
	    acao == "r" && pktsize >= 1000) {
		if (tempo > stopTime) {
			stopTime = tempo
		}
		
		
		hdr_size = pktsize % 1000
		pktsize -= hdr_size
		
		# Armazena tamanho dos pacotes recebidos
		
		recvdSize += pktsize
		
		# Tempo de recepo dos pacotes
		
		recvTime[packet_id] = tempo
		
	}
	
	
##################################################################################################################################################################
#                                                                                                                                                                #
#                              rea de clculo da mdia dos atrasos dos pacotes                                                                                  #
#                                                                                                                                                                #  
##################################################################################################################################################################
	
	
	
	delay = avg_delay = recvdNum = 0
	for (i in recvTime) {
		if (sendTime[i] == 0) {
			printf("\n Erro no atraso: recebeu um pacote que no foi enviado %g\n",i)
		}
		delay += recvTime[i] - sendTime[i]
		recvdNum ++
	}
	if (recvdNum != 0) {
		avg_delay = delay / recvdNum
	} else {
		avg_delay = 0
	}
	
	

##################################################################################################################################################################
#                                                                                                                                                                #
#                              rea de clculo dos pacotes transmitidos e pacotes perdidos                                                                       #
#                                                                                                                                                                #  
##################################################################################################################################################################

if (fonte==0 && destino==1 && acao == "+")

numFs++;

if (flow_id==0 && acao== "d")

fsDrops++;

}

END {




			   
#################################################################################################################################################################
#                                                                                                                                                               #
#                             rea de gerao da tela com os resultados                                                                                         #  
#                                                                                                                                                               #
#################################################################################################################################################################
printf("\n");
printf("####################################################################################################################################################################################### \n");
printf("\n");

printf("UNIVERSIDADE FEDERAL FLUMINENSE - UFF \n");
printf("Pos Graduacao em Computacao \n");
printf("Disciplina de Redes de Computadores - 2017-2 \n");
printf("\n");




if (recvdNum == 0) {
		printf("####################################################################\n" \
		       "#  Atencao: nao foram recebidos pacotes, a simulacao deve ser muito pequena  #\n" \
		       "####################################################################\n\n")

}



printf("\n")
	
	printf(" %80s:  %s\n", "Tipo do trafego usado na simulacao", tipo)
	printf("\n")
	printf(" %80s:  %g\n", "Tamanho do pacote usado na simulacao [bytes]", pktsize)
	
	
	printf("\n")
		
	
	printf(" %80s:  %g\n", "Pacotes transmitidos", numFs)
	printf(" %80s:  %g\n", "Pacotes recebidos", recvdNum)
	printf(" %80s:  %g\n", "Pacotes perdidos ou descartados", fsDrops)
	printf(" %80s:  %g\n", "Vazao media (kbps)", (recvdSize/(stopTime-startTime))*(8/1000))
	printf(" %80s:  %g\n", "Atraso medio (ms)", avg_delay*1000)
	printf("\n")




printf("####################################################################################################################################################################################### \n");



}




