################################################################################################################################################################
#          UNIVERSIDADE FEDERAL FLUMINENSE - UFF                                                                                                               #
#          Ps Graduao em Computao                                                                                                                         #
#          Disciplina de Redes de Computadores - 2017-2                                                                                                        #
#                                                                                                                                                              #
#                                                                                                                                                              #
#                                                                                                                                                              # 
#      Este programa analisa um arquivo Trace com os dados gerados por um trfego FTP sobre TCP e um trafego CBR sobre UDP (em um gargalo) e calcula:          #
#                                                                                                                                                              # 
#                                    			Pacotes enviados;                                                                                      #
#                                    			Pacotes recebidos;                                                                                     # 
#                                                       Pacotes perdidos (descartados) no UDP e pacotes reenviados no TCP;                                     #
#						        Vazo em Kbit/s;                                                                                       #
#                                                       Atraso (ms).                                                                                           # 
#                                                                                                                                                              # 
#                  Observao: Para execut-lo, digitar: $  gawk -f resultados-exemplo2-link23.awk  out-23.tr                                                  # 
#                                                                                                                                                              #
################################################################################################################################################################


BEGIN {



################################################################################################################################################################

#                    rea de inicializao das variveis do programa                   

fsDrops = 0;       

fusDrops = 0;

numFs = 0;         


recvdSize = 0
startTime = 1e8
stopTime = 0

recvdSizeu = 0
startTimeu = 1e8
stopTimeu = 0


################################################################################################################################################################

}



{

acao = $1;

tempo = $2;

fonte = $3;

destino = $4;

tipo = $5;

pktsize = $6;

flow_id = $8;

src = $9;

dst = $10;

seq_no = $11;

packet_id = $12;




##################################################################################################################################################################
#                                                                                                                                                                #
#                              rea de clculo do tempo, tamanho dos pacotes                                                                                     #
#                                                                                                                                                                #  
##################################################################################################################################################################


if (acao == "+" || acao == "-") node_id = $3 
if (acao == "r" || acao == "d") node_id = $4
 
 
		
		
		
###################################################################################################################################################################		
			
# Tempo para enviar os pacotes FTP/TCP


	if (flow_id == 1 && node_id == 2 &&
	    sendTime[packet_id] == 0 && (acao == "+" || acao == "s") && pktsize >= 1000) {
		if (tempo < startTime) {
			startTime = tempo
		}
		sendTime[packet_id] = tempo
		
	}


# Update do total de pacotes recebidos, tamanho e armazenar tempo de pacotes recebidos FTP/TCP


	if (flow_id == 1 && node_id == 3 &&
	    acao == "r" && pktsize >= 1000) {
		if (tempo > stopTime) {
			stopTime = tempo
		}
		
		
		hdr_size = pktsize % 1000
		pktsize -= hdr_size
		
		# Armazena tamanho dos pacotes recebidos
		
		recvdSize += pktsize
		
		# Tempo de recepo dos pacotes
		
		recvTime[packet_id] = tempo
		
	}

###################################################################################################################################################################
###################################################################################################################################################################		
			
# Tempo para enviar os pacotes CBR/UDP


	if (flow_id == 2 && node_id == 2 &&
	    sendTimeu[packet_id] == 0 && (acao == "+" || acao == "s") && pktsize >= 1000) {
		if (tempo < startTimeu) {
			startTimeu = tempo
		}
		sendTimeu[packet_id] = tempo
		
	}


# Update do total de pacotes recebidos, tamanho e armazenar tempo de pacotes recebidos CBR/UDP


	if (flow_id == 2 && node_id == 3 &&
	    acao == "r" && pktsize >= 1000) {
		if (tempo > stopTimeu) {
			stopTimeu = tempo
		}
		
		
		hdr_size = pktsize % 1000
		pktsize -= hdr_size
		
		# Armazena tamanho dos pacotes recebidos
		
		recvdSizeu += pktsize
		
		# Tempo de recepo dos pacotes
		
		recvTimeu[packet_id] = tempo
		
	}

###################################################################################################################################################################

	
##################################################################################################################################################################
#                                                                                                                                                                #
#                              rea de clculo da mdia dos atrasos dos pacotes FTP/TCP                                                                          #
#                                                                                                                                                                #  
##################################################################################################################################################################
	
	
	
	delay = avg_delay = recvdNum = 0
	for (i in recvTime) {
		if (sendTime[i] == 0) {
			printf("\n Erro no atraso: recebeu um pacote que no foi enviado %g\n",i)
		}
		delay += recvTime[i] - sendTime[i]
		recvdNum ++
	}
	if (recvdNum != 0) {
		avg_delay = delay / recvdNum
	} else {
		avg_delay = 0
	}
	
##################################################################################################################################################################	

##################################################################################################################################################################
#                                                                                                                                                                #
#                              rea de clculo da mdia dos atrasos dos pacotes CBR/UDP                                                                          #
#                                                                                                                                                                #  
##################################################################################################################################################################
	
	
	
	delayu = avg_delayu = recvdNumu = 0
	for (i in recvTimeu) {
		if (sendTimeu[i] == 0) {
			printf("\n Erro no atraso: recebeu um pacote que no foi enviado %g\n",i)
		}
		delayu += recvTimeu[i] - sendTimeu[i]
		recvdNumu ++
	}
	if (recvdNumu != 0) {
		avg_delayu = delayu / recvdNumu
	} else {
		avg_delayu = 0
	}
	
##################################################################################################################################################################



##################################################################################################################################################################
#                                                                                                                                                                #
#                              rea de clculo dos pacotes transmitidos e pacotes reenviados para evitar perdas no TCP e pacotes perdidos no UDP                 #
#                                                                                                                                                                #  
##################################################################################################################################################################

if (fonte==2 && destino==3 && acao == "+" && pktsize >= 1000)

numFs++;

if (flow_id==1 && acao== "d")

fsDrops++;

if (flow_id==2 && acao== "d")

fusDrops++;

}

END {




			   
#################################################################################################################################################################
#                                                                                                                                                               #
#                             rea de gerao da tela com os resultados                                                                                         #  
#                                                                                                                                                               #
#################################################################################################################################################################
printf("\n");
printf("####################################################################################################################################################################################### \n");
printf("\n");


printf("UNIVERSIDADE FEDERAL FLUMINENSE - UFF \n");
printf("Pos Graduacao em Computacao \n");
printf("Disciplina de Redes de Computadores - 2017-2 \n");
printf("\n");


if (recvdNum == 0) {
		printf("####################################################################\n" \
		       "#  Atencao: nao foram recebidos pacotes, a simulacao deve ser muito pequena  #\n" \
		       "####################################################################\n\n")

}



	
	printf(" %40s:  \n", "Simulacao no gargalo ou link do no 2 para o no 3 com TCP e UDP") 
	
	
	
	printf("\n")
	
	
	
	
	printf(" %80s:  %g\n", "Total de pacotes transmitidos TCP e UDP", numFs)
	printf("\n")
	printf(" %80s:  %g\n", "Total real de pacotes recebidos do TCP - informacao util", recvdNum)
	printf(" %80s:  %g\n", "Pacotes reenviados para evitar perdas no TCP", fsDrops)
	printf(" %80s:  %g\n", "Vazao media TCP (kbps)", (recvdSize/(stopTime-startTime))*(8/1000))
	printf(" %80s:  %g\n", "Atraso medio TCP (ms)", avg_delay*1000)
	printf("\n")

	printf(" %80s:  %g\n", "Total de pacotes recebidos do UDP", recvdNumu)
	printf(" %80s:  %g\n", "Pacotes perdidos ou descartados no UDP", fusDrops)
	printf(" %80s:  %g\n", "Vazao media UDP (kbps)", (recvdSizeu/(stopTimeu-startTimeu))*(8/1000))
	printf(" %80s:  %g\n", "Atraso medio UDP (ms)", avg_delayu*1000)
	printf("\n")

printf("####################################################################################################################################################################################### \n");



}




